// CPrintJobDlg.cpp : t@C
//
// Copyright (c) 2013 ЃgXgE\tgEFAEVXe, All Rights Reserved.
//

#include "stdafx.h"
#include <Winspool.h>
#include "Vwr.h"
#include "PrintJobDlg.h"


// CPrintJobDlg _CAO

IMPLEMENT_DYNAMIC(CPrintJobDlg, CDialog)

CPrintJobDlg::CPrintJobDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPrintJobDlg::IDD, pParent)
{
}

CPrintJobDlg::~CPrintJobDlg()
{
}

void CPrintJobDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PRT_NAME_1, m_prtName1);
	DDX_Control(pDX, IDC_PRT_NAME_2, m_prtName2);
	DDX_Control(pDX, IDC_PAGE_FROM_1, m_pageFrom1);
	DDX_Control(pDX, IDC_PAGE_FROM_2, m_pageFrom2);
	DDX_Control(pDX, IDC_PAGE_TO_1, m_pageTo1);
	DDX_Control(pDX, IDC_PAGE_TO_2, m_pageTo2);
}


BEGIN_MESSAGE_MAP(CPrintJobDlg, CDialog)
	ON_BN_CLICKED(IDOK, &CPrintJobDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CPrintJobDlg bZ[W nh

INT_PTR CPrintJobDlg::DoModal(CPdfviewer1 *pVwr)
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	pViewer = pVwr;
	pdfNumOfPages = pViewer->get_PageCount();

	return CDialog::DoModal();
}

BOOL CPrintJobDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ɏǉĂ
	if(pdfNumOfPages<2){
		m_pageFrom1.SetWindowText(TEXT("1"));	m_pageFrom1.EnableWindow(false);
		m_pageTo1.SetWindowText(TEXT("1"));		m_pageTo1.EnableWindow(false);
		m_pageFrom2.SetWindowText(TEXT("1"));	m_pageFrom2.EnableWindow(false);
		m_pageTo2.SetWindowText(TEXT("1"));		m_pageTo2.EnableWindow(false);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// O : OCX vpeB y[W͕K FALSE Ԃ܂B
}

void CPrintJobDlg::OnBnClickedOk()
{
	// TODO: ɃRg[ʒmnh R[hǉ܂B
	CString	s;
	int		f, p;

	//ׂē͂ꂽH
	if(m_prtName1.GetWindowTextLength()<1){
		MessageBox(TEXT("P̃v^͂Ă"));
		return;
	}else if(m_pageFrom1.GetWindowTextLength()<1){
		MessageBox(TEXT("PWůJny[W͂Ă"));
		return;
	}else if(m_pageTo1.GetWindowTextLength()<1){
		MessageBox(TEXT("PWȕIy[W͂Ă"));
		return;
	}else if(m_prtName2.GetWindowTextLength()<1){
		MessageBox(TEXT("Q̃v^͂Ă"));
		return;
	}else if(m_pageFrom2.GetWindowTextLength()<1){
		MessageBox(TEXT("QWůJny[W͂Ă"));
		return;
	}else if(m_pageTo2.GetWindowTextLength()<1){
		MessageBox(TEXT("QWȕIy[W͂Ă"));
		return;
	}

	//PWu
	m_pageFrom1.GetWindowText(s);
	if((f=p=_ttoi(s))<1){
		MessageBox(TEXT("PWůJny[W1ȏ̒l͂Ă"));
		m_pageFrom1.SetWindowText(TEXT(""));
		return;
	}else if(p>pdfNumOfPages){
		s.Format(TEXT("PWůJny[W%dȉ̒l͂Ă"), pdfNumOfPages);
		MessageBox(s);
		m_pageTo1.SetWindowText(TEXT(""));
		return;
	}
	m_pageTo1.GetWindowText(s);
	if((p=_ttoi(s))<f){
		s.Format(TEXT("PWȕIy[W%fȏ̒l͂Ă"), f);
		MessageBox(s);
		m_pageFrom1.SetWindowText(TEXT(""));
		return;
	}else if(p>pdfNumOfPages){
		s.Format(TEXT("PWůJny[W%dȉ̒l͂Ă"), pdfNumOfPages);
		MessageBox(s);
		m_pageTo1.SetWindowText(TEXT(""));
		return;
	}

	//QWu
	m_pageFrom2.GetWindowText(s);
	if((f=p=_ttoi(s))<1){
		MessageBox(TEXT("QWůJny[W1ȏ̒l͂Ă"));
		m_pageFrom2.SetWindowText(TEXT(""));
		return;
	}else if(p>pdfNumOfPages){
		s.Format(TEXT("QWůJny[W%dȉ̒l͂Ă"), pdfNumOfPages);
		MessageBox(s);
		m_pageTo2.SetWindowText(TEXT(""));
		return;
	}
	m_pageTo2.GetWindowText(s);
	if((p=_ttoi(s))<f){
		s.Format(TEXT("QWȕIy[W%fȏ̒l͂Ă"), f);
		MessageBox(s);
		m_pageFrom2.SetWindowText(TEXT(""));
		return;
	}else if(p>pdfNumOfPages){
		s.Format(TEXT("QWůJny[W%dȉ̒l͂Ă"), pdfNumOfPages);
		MessageBox(s);
		m_pageTo2.SetWindowText(TEXT(""));
		return;
	}

	//Jn
	//PWu
	m_prtName1.GetWindowText(s);
	if(!pViewer->OpenPrinter(s)){
		MessageBox(TEXT("P̃v^sł"));
		return;
	}else if(!pViewer->BeginDocument(TEXT("The first job."))){
		MessageBox(TEXT("P̃vg WuJnł܂ł"));
		return;
	}
	m_pageFrom1.GetWindowText(s);
	f = _ttoi(s);
	m_pageTo1.GetWindowText(s);
	p = _ttoi(s);
	for(int i=f; i<=p; i++){
		if(!pViewer->PrintPage((long)i)){
			MessageBox(TEXT("P̃vg Wus܂"));
			return;
		}
	}
	pViewer->EndDocument();
	pViewer->ClosePrinter();
	if(pdfNumOfPages<2){ OnOK(); return; }

	//QWu
	m_prtName2.GetWindowText(s);
	if(!pViewer->OpenPrinter(s)){
		MessageBox(TEXT("Q̃v^sł"));
		return;
	}
	if(!pViewer->BeginDocument(TEXT("The second job."))){
		MessageBox(TEXT("Q̃vg WuJnł܂ł"));
		return;
	}
	m_pageFrom2.GetWindowText(s);
	f = _ttoi(s);
	m_pageTo2.GetWindowText(s);
	p = _ttoi(s);
	for(int i=f; i<=p; i++){
		if(!pViewer->PrintPage((long)i)){
			MessageBox(TEXT("Q̃vg Wus܂"));
			return;
		}
	}
	pViewer->EndDocument();
	pViewer->ClosePrinter();

	OnOK();
}
